// ---------------------------------------------------------------------------
//
//      The ab-initio based multiscale library
//
//                  S / P H I / n X
//
//      Copyright:  Max-Planck-Institute for Iron Research
//                  40237 Duesseldorf, Germany
//
//      Contact:    https://sxlib.mpie.de
//      Authors:    see sphinx/AUTHORS
//      License:    see sphinx/LICENSE
//
// ---------------------------------------------------------------------------

#ifndef _SX_HIST2CORR_H_
#define _SX_HIST2CORR_H_

#include <SxString.h>
#include <SxExt.h>
/** \brief A tool to deal with md trajectories to calculate 
           mascroscopic observables
    \ingroup  group_addons
    \author   Lars Ismer, ismer@fhi-berlin.mpg.de */
class SX_EXPORT_EXT SxHist2Corr 
{
   public:
      SxHist2Corr ();
      ~SxHist2Corr ();
      void printUsage ();
      void printHelp ();
      /** \brief load matrix from sx format */
      int saveMatrixSx (const SxMatrix<Double> &, const SxString &);
   
   protected:
};


#endif /* _SX_HIST2CORR_ */
