// ---------------------------------------------------------------------------
//
//      The ab-initio based multiscale library
//
//                  S / P H I / n X
//
//      Copyright:  Max-Planck-Institute for Iron Research
//                  40237 Duesseldorf, Germany
//
//      Contact:    https://sxlib.mpie.de
//      Authors:    see sphinx/AUTHORS
//      License:    see sphinx/LICENSE
//
// ---------------------------------------------------------------------------

//Uebernommen aus anderen SxWelk Programmen
#include <stdio.h>
#include <stdlib.h>
#include <SxVector.h>
#include <SxMatrix.h>
#include <SxCLI.h>
#include <SxUtil.h>
#include <SxParser.h>
#include <SxConstants.h>


int main (int argc, char **argv) 
{
   SxCLI cli(argc, argv);
   cli.preUsageMessage
      = SxString("Was passiert hier").wrap ();

//*1*---Dimension des Vektors/der Matrix beim Abruf des Programs bestimmen: Pfad_-n_4(Dimension 4x4/4)--
// int n = cli.option ("-n|--dim", "integer", "dimension of vector").toInt (3,3,100);
   cli.finalize ();


// Idee: Matrix aufsetzen 
   int n=7;
   SxVector<Double> v1(n);
   SxMatrix<Double> m1(n,n);
   SxVector<Double> F1(n);


//*1*--fuer Bsp einer 4x4 Dimension und einer 3x3 Matrizenvorgabe(s.u.) "leere Plaetze" mit 1.5 auffuellen, bzw fuer den Vektor weitere komponenten gleich Null setzen
// v1.set(0.0);
// m1.set(1.5);

/* Matrix definieren/aufsetzen
   m1(0,0)= 1; m1(0,1)= -1; m1(0,2)= 0;
   m1(1,0)= -1; m1(1,1)= 2; m1(1,2)= -1;
   m1(2,0)= 0; m1(2,1)= -1; m1(2,2)= 1;*/

 
//
/*   v1(0)=0; v1(1)=1; v1(2)=0;*/


//--Vektor F1(Speicherplatz)=Matrix*Vektor(Operation)---------------
/*   F1=m1^v1;

   m1.print(true);
   
   v1.print(true);

   F1.print(true);*/



//----------m1 1. und letzte Zeile definieren--------------
   for (int v=0; v<n; v++)  {

   m1(0,0)=1; m1(0,1)=-1; 
   if ( v>1)  {
    m1(0,v)=0;
   }  
   m1((n-1),(n-2))=-1; m1((n-1),(n-1))=1; 
   if (v<(n-2))  {
     m1((n-1),v)=0;
   }
   }

//-------->>>>>>fuer Matrix hebt sich Fi Summe nicht auf bisher, eventl liegt's an der 1. und letzten Zeilen Definition///////////
//---------Matrix ueber for-Schleife----------------
   for (int w=1; w<(n-1); w++)  {
      for (int v=0; v<n; v++)  {
         if(w==v)  {
            m1(w,v)=2;
         } else if(w==(v-1))  {
            m1(w,v)=-1;
         } else if(w==(v+1)){
            m1(w,v)=-1;
         } else {
            m1(w,v)=0;
         }
      }
   }

   cout << "m1=";
   m1.print(true);



///////////////////alternative und effektivere Eingabe////////////////////////////   
   for (int nInputs = 0; nInputs < 100; nInputs++)  { //wiederholt die Schleife um versch Werte durchyuspielen
      for (int iv = 0; iv < n; iv++)  {
         cout << "v(" << (iv+1) << ")=";
         int numbersSuccessfullyReadIn = scanf ("%lf", &(v1(iv)));
         if (numbersSuccessfullyReadIn != 1) {
           cout << "Illegal input (should be a number)" << endl;
           SX_QUIT;
         }
      }
      cout << "v1=";
      v1.print (true);
      cout << "F1=";
      F1 = m1 ^ v1;
      F1.print (true);
      /*cout << "sum(F1)=";
      F1.sum();*/
   }

  return 0;
}
