// ---------------------------------------------------------------------------
//
//      The ab-initio based multiscale library
//
//                  S / P H I / n X
//
//      Copyright:  Max-Planck-Institute for Iron Research
//                  40237 Duesseldorf, Germany
//
//      Contact:    https://sxlib.mpie.de
//      Authors:    see sphinx/AUTHORS
//      License:    see sphinx/LICENSE
//
// ---------------------------------------------------------------------------

//Uebernommen aus anderen SxWelk Programmen
#include <stdio.h>
#include <stdlib.h>
#include <SxVector.h>
#include <SxMatrix.h>
#include <SxCLI.h>
#include <SxUtil.h>
#include <SxParser.h>
#include <SxConstants.h>
#include <iostream>
#include <SxList.h>
#include <fstream>
using namespace std;

#define TYPE_V2 Double


int main (int argc, char **argv) 
{
   SxCLI cli(argc, argv);
   cli.preUsageMessage
      = SxString("Was passiert hier").wrap ();

   cli.finalize ();



   int n=10;
   SxVector<Double> v1(n);// variabler Vektor
   SxVector<Double> v2(n);// Vektor "fixed"
   SxMatrix<Double> m1(n,n);// WW-Matrix 
   SxMatrix<Double> m2(n,n);// Matrix periodische Randbedingung
   SxMatrix<Double> m2inv(n,n);// inverse Matrix periodische Randbedingung
   SxMatrix<Double> D1(n,n);// modifizierte Matrix auf Vektorfixed
   SxMatrix<Double> Dinvs(n,n);// D1 invertiert
   SxMatrix<Double> testD(n,n);// D1^Dinv
   SxVector<Double> F1(n);// Kraftvektor WW-Matrix
   SxVector<Double> F2(n);// KraftVektor fuer modifizierte Matrix
   SxVector<Double> Ftrue(n);// Kraftvektor Kraft nach Verrueckung im GW
   SxVector<Double> Freal(n);// Kraftvektor tatsaechliche Kraft
   SxList<int> fixedIdx;
   SxList<double> fixedVal;


//---------m1 1. und letzte Zeile definieren--------------
   for (int v=0; v<n; v++)  {

   m1(0,0)=-1; m1(0,1)=1; 
   if ( v>1)  {
    m1(0,v)=0;
   }  
   m1((n-1),(n-2))=1; m1((n-1),(n-1))=-1; 
   if (v<(n-2))  {
     m1((n-1),v)=0;
   }
   }
//           "Hauptteil"Matrix ueber for-Schleife
   for (int w=1; w<(n-1); w++)  {
      for (int v=0; v<n; v++)  {
         if(w==v)  {
            m1(w,v)=-2;
         } else if(w==(v-1))  {
            m1(w,v)=1;
         } else if(w==(v+1)){
            m1(w,v)=1;
         } else {
            m1(w,v)=0;
         }
      }
   }
//---------------------------------------------------------------------------
//   cout << "m1=\n";
//   m1.print(true);



     
//-----------------------------mit SxList "fixed-Werte" definieren------------------
   
   // BEFEHL: fixedIdx << 0 << 6 << 12;
   // fixedIdx =0:0; =1:6; =2:12; fixedIdx(0)=0; fI(1)=6; fI(2)=12
   // entsprechend fuer Value
  
	fixedIdx << 3 << 9;// << 18 ; //Vektorkomponenten
   fixedVal << -1.2 << 2;// << 2.25; //Wert des Eintrages

/*   
//-----------------------------mit SxList v2 "fix-Vektor" definieren------------------
   for (int x = 0; x < n; x++)  {
         if (x== fixedIdx()) {//[fixedIdx=0 : 1 ; =1 : 3]
            v2(x)= fixedVal();
         } else if (x== fixedIdx(10)) {
            v2(x)=fixedVal(2);
         } else if (x== fixedIdx(18)) {
            v2(x)=fixedVal(2.25);
         } else {
         cout << "v2(" << (x) << ")=";
            int numbersSuccessfullyReadIn = scanf ("%lf", &(v2(x)));
         if (numbersSuccessfullyReadIn != 1) {
           cout << "Illegal input (should be a number)" << endl;
           SX_QUIT;
         }
         }
   
   }
//--------------------------------------------------------------------------------------
*/


//------------KOPIE um modifizierte Matrix D1 zu erstellen!!!!!!!!!!!!---------------

   D1 = m1.getCopy ();

//   cout << "D1=\n";
//   D1.print(true); 

//------------------------------------modifizierte Matrix-------------

  for (int iFixed=0; iFixed< fixedIdx.getSize(); iFixed++) {
      int i= fixedIdx(iFixed);
         for (int j=0; j<n; ++j) {
            D1(i,j)= (i==j)? 1. : 0.;  //(Bed.)?(Wert true):(Wert false);
         }
   }
//---------------------------------------------------------------------------------
   cout << "D1mod=\n" ;
   D1.print (true);



//----------F2modifiziert-----------
   for (int p=0; p < n; p++){
      for (int iFixed=0; iFixed< fixedIdx.getSize(); iFixed++) {
         int i= fixedIdx(iFixed); 
         if (i == p) {
         F2(p)= fixedVal(iFixed);
         break;
      } else {
         F2(p)=0;
      }
      }
   }


 //  cout << "value at 1 " << fixedIdx(0)  << endl;
   cout << "f2 =" ;
   F2.print (true);
 //  cout << "SumF2= " << F2.sum () << endl; //-->.sum() ohne "true"


//---------D1 Inverse--------------
   Dinvs = D1.inverse();
   cout << "D1inv=\n" ;   
   Dinvs.print(true);

//----------v2 berechnen----------------------   
   v1= Dinvs ^ F2;
   cout << "v1true=";
   v1.print(true);


/*
//----------------------periodische Randbedingungen-----------------
   m2= m1.getCopy();
   for (int v=0; v<n; v++)  {

   m2(0,0)=-2; m2(0,1)=1; m2(0,(n-1))=1;//erste Zeile
   if ( v>1 && v< (n-1))  {
    m2(0,v)=0;
   }  
   m2((n-1),0)=1; m2((n-1),(n-2))=1; m2((n-1),(n-1))=-2;//letzte Zeile 
   if (v>0 && v<(n-2))  {
     m2((n-1),v)=0;
   }
   }
   
//   cout << "m2=\n";
   m2.print(true);



//------------m2 = periodische Randbedingungen
   Ftrue= m2 ^ v1;
   cout << "Ftrue=";
   Ftrue.print();
   cout << "SumF2= " << Ftrue.sum() << endl;

*/

//-----------Kraft auf einzelne Teilchen-------------
   Freal= m1 ^ F2; //f2=verrueckte Vektoren,entspr verruckgsvektor    
   cout << "Freal=" ;
   Freal.print(true);
   cout << "SumFreal= " << Freal.sum () << endl; //-->.sum() ohne "true"
//------------m1 = modifiz.Matrix lineare Kette
//-------------- v1 aus Berechnung mit modMatr und Fmod einsetzen in Urssprungssituation

   Ftrue= m1 ^ v1;    
   cout << "F=" ;
   Ftrue.print(true);
   cout << "SumFtrue= " << Ftrue.sum () << endl; //-->.sum() ohne "true"



//---------------------visualise-----------------

   double x1,y1;
   ofstream myfile;
   myfile.open ("3atoms.dat");
   for (int i=0; i<n; i++) {
      x1= i + (v1(i));  //Faktor "x*" um Verschiebung zu erkennen!
    //  x1= v1(i);
      y1= 0.4;
      myfile << x1 << " " << y1 << "\n";
   }
   myfile.close ();




  return 0;
}
