// ---------------------------------------------------------------------------
//
//      The ab-initio based multiscale library
//
//                  S / P H I / n X
//
//      Copyright:  Max-Planck-Institute for Iron Research
//                  40237 Duesseldorf, Germany
//
//      Contact:    https://sxlib.mpie.de
//      Authors:    see sphinx/AUTHORS
//      License:    see sphinx/LICENSE
//
// ---------------------------------------------------------------------------

#include <SxFSAction.h>
#include <SxCLI.h>

int main (int argc, char **argv)
{
   SxCLI cli (argc, argv);
   SxString target = cli.option ("--input|-i", "Filename").toString ();
   SxString perms  = cli.option ("--perms|-p", "Permissions").toString ();
   cli.finalize (); 
   
   try  {
      int mode = 0;
      bool error = false;
      mode = perms.toInt (&error);
      if (!error)  {
         SxFSAction::chmod (mode, target);
      }  else  {
         SxFSAction::chmod (perms, target);
      }
   } catch (SxException e)  {
      cout << "ERROR: " << e.getMessage () << endl;
   }
   
   return 0;
}
