// ---------------------------------------------------------------------------
//
//      The ab-initio based multiscale library
//
//                  S / P H I / n X
//
//      Copyright:  Max-Planck-Institute for Iron Research
//                  40237 Duesseldorf, Germany
//
//      Contact:    https://sxlib.mpie.de
//      Authors:    see sphinx/AUTHORS
//      License:    see sphinx/LICENSE
//
// ---------------------------------------------------------------------------

#include <SxProcUnit.h>
#include <SxProcUnitGroup.h>


SxProcUnit::SxProcUnit ()
   : unitId (0)
{
   // empty
}

SxProcUnit::SxProcUnit (const SxPtr<SxProcUnitGroup> &group_)
   : unitId (0)
{
   if (group_)  {
      group = group_;
      group->registerProcUnit (getThis());
   }
}


SxProcUnit::~SxProcUnit ()
{
   if (group)  group->deregisterProcUnit (getThis());
}


//void SxProcUnit::setId (ssize_t id_)
//{
//   unitId = id_;
//}


//ssize_t SxProcUnit::getId () const
//{
//   return unitId;
//}


void SxProcUnit::reparent (const SxPtr<SxProcUnitGroup> &newGroup)
{
   group = newGroup;
   if (group)  group->registerProcUnit (getThis());
}
