// ---------------------------------------------------------------------------
//
//      The ab-initio based multiscale library
//
//                  S / P H I / n X
//
//      Copyright:  Max-Planck-Institute for Iron Research
//                  40237 Duesseldorf, Germany
//
//      Contact:    https://sxlib.mpie.de
//      Authors:    see sphinx/AUTHORS
//      License:    see sphinx/LICENSE
//
// ---------------------------------------------------------------------------

#include <SxVector.h>

#ifndef _SX_MATRIX_H_
#define _SX_MATRIX_H_

#ifdef SXMATBASIS
#   undef SXMATBASIS
#endif
#define SXMATBASIS  SxVector

#ifdef SXMAT
#   undef SXMAT
#endif
#define SXMAT       SxMatrix


#ifdef SXSYMMAT
#   undef SXSYMMAT
#endif
#define SXSYMMAT    SxSymMatrix

#ifdef MEMHANDLE
#   undef MEMHANDLE
#endif
#define MEMHANDLE    SxVectorHandle

#include <SxMat.h>

template <class T>
class SxVecTraits<SxVector<T> > 
{
   public:
   typedef T ScalarType;
   typedef SxMatrix<T> MatType;
};

#endif /* _SX_MATRIX_H_ */
