// ---------------------------------------------------------------------------
//
//      The ab-initio based multiscale library
//
//                  S / P H I / n X
//
//      Copyright:  Max-Planck-Institute for Iron Research
//                  40237 Duesseldorf, Germany
//
//      Contact:    https://sxlib.mpie.de
//      Authors:    see sphinx/AUTHORS
//      License:    see sphinx/LICENSE
//
// ---------------------------------------------------------------------------

inline void SxConstChar::Iterator::inc (ssize_t count)
{
#if USE_CHAR_TIMING
   CharTiming::timing.nIncCalls++;
#endif
   SX_CHECK_VAR (count >= 0, count);
   if (charObj->isUnicode)  {
      const char *origPtr = charObj->start + byteIdx, *ptr = origPtr;
      utf8Inc (&ptr, count);
      byteIdx += ptr - origPtr;
   }
   else  byteIdx += count;
   SX_CHECK (byteIdx <= charObj->getNBytes ());
      // (We may reach 'limit', but never pass it.)
   charIdx += count;
}
