#include <stdio.h>
#include <string.h>
#include <SxError.h>
#include <SxList.h>
#include <SxString.h>
#include <SxBoundPtr.h>

void foo (const SxString &i) { printf ("foo(%s)\n", i.ascii()); }
void fooIso (double val) { printf ("global iso: %g\n", val); }

class A
{
   public:
      A (int i_) : i(i_) { }

      void fooV () { printf ("A::foo()\n"); }
      void foo (const SxString &s) { printf ("A::foo (%s)\nA::i=%d\n", s.ascii(), i); }
      void foo1 (const SxString &s) { printf ("A::foo (%s)\nA::i=%d\n", s.ascii(), i); }
      void fooD (double d) { printf ("A::fooD (%g)\n", d); }
      double fooDD (double d1, double d2) { printf ("A::fooDD (%g,%g)\n", d1, d2); return d1 * d2; }

   protected:
      int i;
};

int main ()
{
   SxPtr<A> a = SxPtr<A>::create (10);
   SxPtr<A> b = SxPtr<A>::create (22);

   // --- create callbacks with signature "void (*)(const SxString &)"
   SxBoundPtr<void,void> stringCB0;
   SxBoundPtr<void,const SxString &> stringCB1, stringCB2, stringCB3, stringCB4;

   stringCB0 = SxBoundPtr<void,void>::create (a, &A::fooV);
   stringCB1 = SxBoundPtr<void,const SxString&>::create (&foo);
   stringCB2 = SxBoundPtr<void,const SxString&>::create (a, &A::foo);
   stringCB3 = SxBoundPtr<void,const SxString&>::create (a, &A::foo1);
   stringCB4 = stringCB2;

   if (stringCB1 != stringCB1)  {
      SX_EXIT;
   }

   // --- create callbacks with signature "double (*)(double,double)"
   SxBoundPtr<double,double,double> doubleCB1;
   doubleCB1 = SxBoundPtr<double,double,double>::create (a, &A::fooDD);

   printf ("doubleCB = %g\n", doubleCB1(10.,20.));



// a = SxPtr<A>::create (100);
// printf ("222: %p\n", stringCB2.receiver.getPtr());

   // ------------------

   stringCB1("hi global");
   stringCB2("hi A");
   stringCB3("hi B");
   stringCB4("hi A'");

// SX_EXIT; // TODO: deregister SxPtr <--> SxBoundPtr + valgrind


   // --- execute callbacks
   
   return 0;
}
